---
updatedAt: 2025-02-14T21:21:14.000Z
agentTools:
  projectIndex: https://developer.liquidplanner.com/llms.txt
---

# Estimates and Time Tracking (LP Classic)

This documentation is for LiquidPlanner Classic: app.liquidplanner.com

## Tracking Time and Updating Estimate

In LiquidPlanner Classic you can update your estimate, track hours worked, and add a comment with a single POST using the `track_time` method on tasks.

NOTE: When you track time via the API, the remaining effort estimate does not decrement automatically like in the UI. You will need to set the `reduce_estimate` parameter to true or pass the `low` and `high` parameters to update the remaining estimate.

The following request tracks four hours of work on a task and sets the remaining estimate to a low of 1.5 days and a high of 3 days:

```curl
% curl -X POST https://app.liquidplanner.com/api/v1/workspaces/:id/tasks/:id/track_time \
       -d '{ "work":"4", "low": "1.5d", "high": "3d", "activity_id":12345}'
```

Available Parameters:

<Table align={["left","left"]}>
  <thead>
    <tr>
      <th style={{ textAlign: "left" }}>
        Parameter
      </th>

      <th style={{ textAlign: "left" }}>
        Description
      </th>
    </tr>
  </thead>

  <tbody>
    <tr>
      <td style={{ textAlign: "left" }}>
        member\_id
      </td>

      <td style={{ textAlign: "left" }}>
        id of the member to track work against and comment as; optional, defaults to you (the current user)

        *NOTE: you cannot track time for virtual members via the API.*
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        work
      </td>

      <td style={{ textAlign: "left" }}>
        hours worked; optional
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        activity\_id
      </td>

      <td style={{ textAlign: "left" }}>
        id of the activity for the work; required if you  provide a value for work
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        low
      </td>

      <td style={{ textAlign: "left" }}>
        low estimate for remaining work, hours (or a string such as “4h”, “0.5d”); usually optional, must be provided if you provide high, and omitted or set to ‘0’ when setting is\_done
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        high
      </td>

      <td style={{ textAlign: "left" }}>
        high estimate for remaining work, hours (or a string such as “4h”, “0.5d”); usually optional, must be provided if you provide low, and omitted or set to ‘0’ when setting is\_done
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        is\_done
      </td>

      <td style={{ textAlign: "left" }}>
        if true, marks task as done; low and high must each be omitted or explicitly zero
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        done\_on
      </td>

      <td style={{ textAlign: "left" }}>
        datetime on which the task was done; valid only when is\_done=true, defaults to now
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        work\_performed\_on
      </td>

      <td style={{ textAlign: "left" }}>
        date on which the work was performed, default today
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        comment
      </td>

      <td style={{ textAlign: "left" }}>
        comment to add to the task (use <br/> for line break), optional
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        note
      </td>

      <td style={{ textAlign: "left" }}>
        note to add to the timesheet entry (use \n for line break), optional
      </td>
    </tr>

    <tr>
      <td style={{ textAlign: "left" }}>
        reduce\_estimate
      </td>

      <td style={{ textAlign: "left" }}>
        if true, reduces high and low remaining effort estimates by the hours in the work parameter; optional
      </td>
    </tr>
  </tbody>
</Table>

## Updating and Deleting Tracked Time

To update or delete existing tracked time, use `append` URL parameter.

`Append` is true by default. When `append` is true, track\_time will add the work amount to the existing tracked time for any treeitem, member, activity and date combination.

If `append` set to false, track\_time will override the existing timesheet entry value.

Calling track\_time for any existing treeitem, member, activity, and date combination with `append` is set to false will replace the corresponding logged time with the `work` amount specified in the request body.

Calling track\_time for any existing treeitem, member, activity and date combination with `append` set to false and `work=0` will delete the existing time entry.

Example of updating an existing time entry:

```curl
% curl -X POST https://app.liquidplanner.com/api/v1/workspaces/:id/tasks/:id/track_time?append=false
\
       -d '{"member_id": 123, "work":"4", "activity_id":12345, "work_performed_on": "2017-12-13"}'
```